    PROGRAM f07phfe

!      F07PHF Example Program Text

!      Mark 23 Release. NAG Copyright 2011.

!      .. Use Statements ..
       USE nag_library, ONLY : dsprfs, dsptrf, dsptrs, nag_wp, x04caf
!      .. Implicit None Statement ..
       IMPLICIT NONE
!      .. Parameters ..
       INTEGER, PARAMETER              :: nin = 5, nout = 6
!      .. Local Scalars ..
       INTEGER                         :: i, ifail, info, j, ldb, ldx, len, n, &
                                          nrhs
       CHARACTER (1)                   :: uplo
!      .. Local Arrays ..
       REAL (KIND=nag_wp), ALLOCATABLE :: afp(:), ap(:), b(:,:), berr(:),      &
                                          ferr(:), work(:), x(:,:)
       INTEGER, ALLOCATABLE            :: ipiv(:), iwork(:)
!      .. Executable Statements ..
       WRITE (nout,*) 'F07PHF Example Program Results'
!      Skip heading in data file
       READ (nin,*)
       READ (nin,*) n, nrhs
       ldb = n
       ldx = n
       len = n*(n+1)/2
       ALLOCATE (afp(len),ap(len),b(ldb,nrhs),berr(nrhs),ferr(nrhs),work(3*n), &
          x(ldx,n),ipiv(n),iwork(n))

!      Read A and B from data file, and copy A to AFP and B to X

       READ (nin,*) uplo
       IF (uplo=='U') THEN
          READ (nin,*) ((ap(i+j*(j-1)/2),j=i,n),i=1,n)
       ELSE IF (uplo=='L') THEN
          READ (nin,*) ((ap(i+(2*n-j)*(j-1)/2),j=1,i),i=1,n)
       END IF
       READ (nin,*) (b(i,1:nrhs),i=1,n)

       afp(1:len) = ap(1:len)
       x(1:n,1:nrhs) = b(1:n,1:nrhs)

!      Factorize A in the array AFP
!      The NAG name equivalent of dsptrf is f07pdf
       CALL dsptrf(uplo,n,afp,ipiv,info)

       WRITE (nout,*)
       FLUSH (nout)
       IF (info==0) THEN

!         Compute solution in the array X
!         The NAG name equivalent of dsptrs is f07pef
          CALL dsptrs(uplo,n,nrhs,afp,ipiv,x,ldx,info)

!         Improve solution, and compute backward errors and
!         estimated bounds on the forward errors

!         The NAG name equivalent of dsprfs is f07phf
          CALL dsprfs(uplo,n,nrhs,ap,afp,ipiv,b,ldb,x,ldx,ferr,berr,work, &
             iwork,info)

!         Print solution

!         ifail: behaviour on error exit
!                =0 for hard exit, =1 for quiet-soft, =-1 for noisy-soft
          ifail = 0
          CALL x04caf('General',' ',n,nrhs,x,ldx,'Solution(s)',ifail)

          WRITE (nout,*)
          WRITE (nout,*) 'Backward errors (machine-dependent)'
          WRITE (nout,99999) berr(1:nrhs)
          WRITE (nout,*) 'Estimated forward error bounds (machine-dependent)'
          WRITE (nout,99999) ferr(1:nrhs)
       ELSE
          WRITE (nout,*) 'The factor D is singular'
       END IF

99999  FORMAT ((3X,1P,7E11.1))
    END PROGRAM f07phfe
